#include "service.grpc.pb.h"

#include <grpcpp/server.h>
#include <grpcpp/server_builder.h>
#include <grpcpp/security/server_credentials.h>

#include <unistd.h>

using namespace std;

struct TestServiceImpl final : public TestService::Service
{
    virtual grpc::Status DataStream(grpc::ServerContext* context,
                                    grpc::ServerReaderWriter<Data, Data>* stream) override {
        Data data;
        while (stream->Read(&data)) {
            if (!stream->Write(data)) {
                cerr << "server write error" << endl;
                _exit(1);
            }
        }
        return grpc::Status(grpc::StatusCode::UNKNOWN, "server read error");
    }
};

int
main(int argc, char* argv[])
{
    TestServiceImpl test_service;

    string addr = "127.0.0.1:7777";
    grpc::ServerBuilder builder;
    builder.AddListeningPort(addr, grpc::InsecureServerCredentials());
    builder.RegisterService(&test_service);
    unique_ptr<grpc::Server> server(builder.BuildAndStart());
    cout << "Server listening on " << addr << endl;
    server->Wait();
}
